def pow_tail(b, n, p):
    if n == 0:
        return p
    else:
        return pow_tail(b, n - 1, p * b)


def pow_tail_recursive_wrapper(b, n):
    return pow_tail(b, n, 1)


def pow_iter(b, n):
    p = 1
    for i in range(n):
        p *= b
    return p


print(pow_tail_recursive_wrapper(2, 3))
print(pow_tail_recursive_wrapper(2.5, 3))
print(pow_tail_recursive_wrapper(2.5, 0))
print(pow_iter(2, 3))